/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.fsa;

import java.util.Iterator;

import javax.swing.*;


/**
 * No comment provided by developer, please add a comment to improve documentation.
 *
 * @author    $Author: lowende $
 * @version   $Revision: 1.10 $
 */
public class JComponentAsFSAIterator implements Iterator
{
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private Iterator iterator;


   /**
    * Constructor for class JComponentAsFSAIterator
    *
    * @param iter  No description provided
    */
   public JComponentAsFSAIterator (Iterator iter)
   {
      this.iterator = iter;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   public boolean hasNext()
   {
      if (this.iterator != null)
      {
         return this.iterator.hasNext();
      }
      else
      {
         throw new UnsupportedOperationException ("Underlying Iterator is null!");
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   public Object next()
   {
      if (this.iterator != null)
      {
         Object o = this.iterator.next();
         return FSAObject.getFSAObjectFromJComponent ((JComponent) o);
      }
      else
      {
         throw new UnsupportedOperationException ("Underlying Iterator is null!");
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public void remove()
   {
      if (this.iterator != null)
      {
         this.iterator.remove();
      }
      else
      {
         throw new UnsupportedOperationException ("Underlying Iterator is null!");
      }
   }
}

/*
 * $Log: JComponentAsFSAIterator.java,v $
 * Revision 1.10  2004/11/03 10:17:53  lowende
 * Javadoc warnings removed.
 *
 */
