/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.views.cf.unparse;

import java.awt.*;

import javax.swing.*;

import de.uni_paderborn.fujaba.fsa.*;
import de.uni_paderborn.fujaba.fsa.swing.border.LineBorder;
import de.uni_paderborn.fujaba.fsa.unparse.AbstractUnparseModule;
import de.uni_paderborn.fujaba.fsa.unparse.LogicUnparseInterface;
import de.uni_paderborn.fujaba.fsa.update.AbstractUpdater;
import de.uni_paderborn.fujaba.fsa.update.IntStringTranslator;
import de.uni_paderborn.fujaba.views.FilterManager;


/**
 * No comment provided by developer, please add a comment to improve documentation.
 *
 * @author    $Author: schneider $
 * @version   $Revision: 1.12 $
 */
public class UMCFFilterNode extends AbstractUnparseModule
{
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param parent  No description provided
    * @param incr    No description provided
    * @return        No description provided
    */
   public FSAObject create (FSAObject parent, LogicUnparseInterface incr)
   {
      FSAPanel panel = new FSAPanel (incr, getMainFsaName(), parent.getJComponent());
      panel.setLayout (new BoxLayout (panel.getJComponent(), BoxLayout.Y_AXIS));
      panel.setBorder (new LineBorder (Color.black));

      FSAPanel titlePanel = new FSAPanel (incr, "titlePanel", panel.getJComponent());
      titlePanel.setLayout (new FlowLayout (FlowLayout.CENTER));

      FSAComboBoxLabel filterLabel = new FSAComboBoxLabel (incr, "filter", titlePanel.getJComponent());
      filterLabel.setModel (FilterManager.get().getListModel (null));
      filterLabel.addToUpdater (filterLabel.createDefaultUpdater());

      FSAPanel contextPanel = new FSAPanel (incr, "contextPanel", panel.getJComponent());
      contextPanel.setLayout (new FlowLayout (FlowLayout.CENTER));

      FSALabel tmpLabel = new FSALabel (incr, "openBracket", contextPanel.getJComponent());
      tmpLabel.setText ("(");

      FSATextFieldLabel contextLabel = new FSATextFieldLabel (incr, "context", contextPanel.getJComponent());
      AbstractUpdater updater = contextLabel.createDefaultUpdater();
      updater.setTranslator (IntStringTranslator.get());
      contextLabel.addToUpdater (updater);

      tmpLabel = new FSALabel (incr, "closedBracket", contextPanel.getJComponent());
      tmpLabel.setText (")");

      //FSAPanel lastStepPanel=new FSAPanel(incr, "lastStepPanel", panel.getJComponent());
      //lastStepPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));

      return panel;
   }
}

/*
 * $Log: UMCFFilterNode.java,v $
 * Revision 1.12  2004/10/20 17:50:32  schneider
 * Introduction of interfaces for class diagram classes
 *
 */
