package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class AbstractFactoryEngine
extends GFRNEngine
{
   private  AbstractFactoryEngine()
   {
   }

   private static AbstractFactoryEngine theAbstractFactoryEngine;

   public static AbstractFactoryEngine get()
   {
      if (theAbstractFactoryEngine == null)
      {
         theAbstractFactoryEngine = new AbstractFactoryEngine ();
      }
      return theAbstractFactoryEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation abstractFactory = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         abstractFactory = this.annotateUsingTrigger_FactoryMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( abstractFactory != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (abstractFactory) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            abstractFactory = this.annotateUsingConcreteFactoryRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( abstractFactory != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (abstractFactory) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               abstractFactory = this.annotateUsingAbstractFactoryRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            return (abstractFactory) ;
         }
      }
   }


   private GFRNAnnotation annotateUsingAbstractFactoryRole(ASGElement asgElement)
   {
      AbstractFactoryAnnotation abstractFactory = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod = null ;
      Iterator fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod3 = null ;
      Iterator fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory = null ;
      Iterator fujaba__IterFactoryMethod3ElementsConcreteFactoryMethod = null ;
      FactoryMethodAnnotation factoryMethod3 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass abstractFactoryClass = null ;
      UMLClass concreteFactoryClass = null ;
      UMLMethod abstractFactoryMethod = null ;
      UMLMethod concreteFactoryMethod = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("abstractFactory", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractFactoryClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (abstractFactoryClass.isAbstract () == true) ) ;
             
            // bind abstractFactoryMethod: UMLMethod
            fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod = abstractFactoryClass.iteratorOfMethods () ;
            while ( fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod.hasNext () )
            {
               try
               {
                  abstractFactoryMethod = (UMLMethod) fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
                   
                  // bind factoryMethod3: FactoryMethodAnnotation
                  fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod3 = abstractFactoryMethod.iteratorOfAnnotations () ;
                  while ( fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod3.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod3.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof FactoryMethodAnnotation ) ;
                        factoryMethod3 = (FactoryMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between factoryMethod3 and abstractFactoryMethod
                        JavaSDM.ensure ( factoryMethod3.hasInElements ("abstractMethod", abstractFactoryMethod) ) ;
                         
                        // bind concreteFactoryMethod: UMLMethod
                        fujaba__IterFactoryMethod3ElementsConcreteFactoryMethod = factoryMethod3.iteratorOfElements ("concreteMethod") ;
                        while ( fujaba__IterFactoryMethod3ElementsConcreteFactoryMethod.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterFactoryMethod3ElementsConcreteFactoryMethod.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              concreteFactoryMethod = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                               
                              // bind concreteFactoryClass: UMLClass
                              concreteFactoryClass = concreteFactoryMethod.getParent () ;
                              JavaSDM.ensure ( concreteFactoryClass != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (concreteFactoryClass.isAbstract () == false) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstractFactoryClass.equals (concreteFactoryClass)) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object concreteFactoryClass is really bound
                                    JavaSDM.ensure ( concreteFactoryClass != null ) ;
                                     
                                    // check object abstractFactoryClass is really bound
                                    JavaSDM.ensure ( abstractFactoryClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                                     
                                    // bind abstractFactory: AbstractFactoryAnnotation
                                    fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory = concreteFactoryClass.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof AbstractFactoryAnnotation ) ;
                                          abstractFactory = (AbstractFactoryAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between abstractFactory and concreteFactoryClass
                                          JavaSDM.ensure ( abstractFactory.hasInElements ("concreteFactory", concreteFactoryClass) ) ;
                                           
                                          // check To-Many-Link 'elements' between abstractFactory and abstractFactoryClass
                                          JavaSDM.ensure ( abstractFactory.hasInElements ("abstractFactory", abstractFactoryClass) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object concreteFactoryClass is really bound
                                       JavaSDM.ensure ( concreteFactoryClass != null ) ;
                                        
                                       // check object abstractFactoryClass is really bound
                                       JavaSDM.ensure ( abstractFactoryClass != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                                        
                                       // check object concreteFactoryMethod is really bound
                                       JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                        
                                       // check object abstractFactoryMethod is really bound
                                       JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                                        
                                       // create object
                                       abstractFactory = new AbstractFactoryAnnotation ( ) ;
                                        
                                       // assign statement
                                       abstractFactory.setClassification (1);
                                        
                                       // create link
                                       abstractFactory.addToElements ("concreteFactory", concreteFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToElements ("abstractFactory", abstractFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("concreteFactoryMethod", concreteFactoryMethod);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("concreteFactoryClass", concreteFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("abstractFactoryClass", abstractFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("abstractFactoryMethod", abstractFactoryMethod);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object factoryMethod3 is really bound
                                       JavaSDM.ensure ( factoryMethod3 != null ) ;
                                        
                                       // check object abstractFactory is really bound
                                       JavaSDM.ensure ( abstractFactory != null ) ;
                                        
                                       // create link
                                       abstractFactory.addToAntecedentAnnos (factoryMethod3);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (abstractFactory) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object abstractFactory is really bound
            JavaSDM.ensure ( abstractFactory != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("abstractFactory", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (abstractFactory) ;
   }


   private GFRNAnnotation annotateUsingConcreteFactoryRole(ASGElement asgElement)
   {
      AbstractFactoryAnnotation abstractFactory = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory = null ;
      Iterator fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod = null ;
      Iterator fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod2 = null ;
      Iterator fujaba__IterFactoryMethod2ElementsAbstractFactoryMethod = null ;
      FactoryMethodAnnotation factoryMethod2 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass abstractFactoryClass = null ;
      UMLClass concreteFactoryClass = null ;
      UMLMethod abstractFactoryMethod = null ;
      UMLMethod concreteFactoryMethod = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("concreteFactory", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            concreteFactoryClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (concreteFactoryClass.isAbstract () == false) ) ;
             
            // bind concreteFactoryMethod: UMLMethod
            fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod = concreteFactoryClass.iteratorOfMethods () ;
            while ( fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod.hasNext () )
            {
               try
               {
                  concreteFactoryMethod = (UMLMethod) fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                   
                  // bind factoryMethod2: FactoryMethodAnnotation
                  fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod2 = concreteFactoryMethod.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof FactoryMethodAnnotation ) ;
                        factoryMethod2 = (FactoryMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between factoryMethod2 and concreteFactoryMethod
                        JavaSDM.ensure ( factoryMethod2.hasInElements ("concreteMethod", concreteFactoryMethod) ) ;
                         
                        // bind abstractFactoryMethod: UMLMethod
                        fujaba__IterFactoryMethod2ElementsAbstractFactoryMethod = factoryMethod2.iteratorOfElements ("abstractMethod") ;
                        while ( fujaba__IterFactoryMethod2ElementsAbstractFactoryMethod.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterFactoryMethod2ElementsAbstractFactoryMethod.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              abstractFactoryMethod = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                               
                              // bind abstractFactoryClass: UMLClass
                              abstractFactoryClass = abstractFactoryMethod.getParent () ;
                              JavaSDM.ensure ( abstractFactoryClass != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractFactoryClass.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object concreteFactoryClass is really bound
                                    JavaSDM.ensure ( concreteFactoryClass != null ) ;
                                     
                                    // check object abstractFactoryClass is really bound
                                    JavaSDM.ensure ( abstractFactoryClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                                     
                                    // bind abstractFactory: AbstractFactoryAnnotation
                                    fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory = concreteFactoryClass.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterConcreteFactoryClassAnnotationsAbstractFactory.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof AbstractFactoryAnnotation ) ;
                                          abstractFactory = (AbstractFactoryAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between abstractFactory and concreteFactoryClass
                                          JavaSDM.ensure ( abstractFactory.hasInElements ("concreteFactory", concreteFactoryClass) ) ;
                                           
                                          // check To-Many-Link 'elements' between abstractFactory and abstractFactoryClass
                                          JavaSDM.ensure ( abstractFactory.hasInElements ("abstractFactory", abstractFactoryClass) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object concreteFactoryClass is really bound
                                       JavaSDM.ensure ( concreteFactoryClass != null ) ;
                                        
                                       // check object abstractFactoryClass is really bound
                                       JavaSDM.ensure ( abstractFactoryClass != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                                        
                                       // check object concreteFactoryMethod is really bound
                                       JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                        
                                       // check object abstractFactoryMethod is really bound
                                       JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                                        
                                       // create object
                                       abstractFactory = new AbstractFactoryAnnotation ( ) ;
                                        
                                       // assign statement
                                       abstractFactory.setClassification (1);
                                        
                                       // create link
                                       abstractFactory.addToElements ("concreteFactory", concreteFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToElements ("abstractFactory", abstractFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("concreteFactoryMethod", concreteFactoryMethod);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("concreteFactoryClass", concreteFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("abstractFactoryClass", abstractFactoryClass);
                                        
                                       // create link
                                       abstractFactory.addToBoundObjects ("abstractFactoryMethod", abstractFactoryMethod);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object factoryMethod2 is really bound
                                       JavaSDM.ensure ( factoryMethod2 != null ) ;
                                        
                                       // check object abstractFactory is really bound
                                       JavaSDM.ensure ( abstractFactory != null ) ;
                                        
                                       // create link
                                       abstractFactory.addToAntecedentAnnos (factoryMethod2);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (abstractFactory) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object abstractFactory is really bound
            JavaSDM.ensure ( abstractFactory != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("concreteFactory", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (abstractFactory) ;
   }


   private GFRNAnnotation annotateUsingTrigger_FactoryMethodRole(ASGElement asgElement)
   {
      AbstractFactoryAnnotation abstractFactory = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractFactoryClassAnnotationsAbstractFactory = null ;
      Iterator fujaba__IterFactoryMethod1ElementsAbstractFactoryMethod = null ;
      Iterator fujaba__IterFactoryMethod1ElementsConcreteFactoryMethod = null ;
      FactoryMethodAnnotation factoryMethod1 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass abstractFactoryClass = null ;
      UMLClass concreteFactoryClass = null ;
      UMLMethod abstractFactoryMethod = null ;
      UMLMethod concreteFactoryMethod = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_FactoryMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof FactoryMethodAnnotation ) ;
             
            // explicit type cast
            factoryMethod1 = (FactoryMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteFactoryMethod: UMLMethod
            fujaba__IterFactoryMethod1ElementsConcreteFactoryMethod = factoryMethod1.iteratorOfElements ("concreteMethod") ;
            while ( fujaba__IterFactoryMethod1ElementsConcreteFactoryMethod.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterFactoryMethod1ElementsConcreteFactoryMethod.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteFactoryMethod = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                   
                  // bind concreteFactoryClass: UMLClass
                  concreteFactoryClass = concreteFactoryMethod.getParent () ;
                  JavaSDM.ensure ( concreteFactoryClass != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteFactoryClass.isAbstract () == false) ) ;
                   
                  // bind abstractFactoryMethod: UMLMethod
                  fujaba__IterFactoryMethod1ElementsAbstractFactoryMethod = factoryMethod1.iteratorOfElements ("abstractMethod") ;
                  while ( fujaba__IterFactoryMethod1ElementsAbstractFactoryMethod.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterFactoryMethod1ElementsAbstractFactoryMethod.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        abstractFactoryMethod = (UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                         
                        // bind abstractFactoryClass: UMLClass
                        abstractFactoryClass = abstractFactoryMethod.getParent () ;
                        JavaSDM.ensure ( abstractFactoryClass != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractFactoryClass.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object concreteFactoryClass is really bound
                              JavaSDM.ensure ( concreteFactoryClass != null ) ;
                               
                              // check object abstractFactoryClass is really bound
                              JavaSDM.ensure ( abstractFactoryClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                               
                              // bind abstractFactory: AbstractFactoryAnnotation
                              fujaba__IterAbstractFactoryClassAnnotationsAbstractFactory = abstractFactoryClass.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterAbstractFactoryClassAnnotationsAbstractFactory.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractFactoryClassAnnotationsAbstractFactory.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof AbstractFactoryAnnotation ) ;
                                    abstractFactory = (AbstractFactoryAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between abstractFactory and abstractFactoryClass
                                    JavaSDM.ensure ( abstractFactory.hasInElements ("abstractFactory", abstractFactoryClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between abstractFactory and concreteFactoryClass
                                    JavaSDM.ensure ( abstractFactory.hasInElements ("concreteFactory", concreteFactoryClass) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object concreteFactoryClass is really bound
                                 JavaSDM.ensure ( concreteFactoryClass != null ) ;
                                  
                                 // check object abstractFactoryClass is really bound
                                 JavaSDM.ensure ( abstractFactoryClass != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(concreteFactoryClass.equals (abstractFactoryClass)) ) ;
                                  
                                 // check object concreteFactoryMethod is really bound
                                 JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                  
                                 // check object abstractFactoryMethod is really bound
                                 JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                                  
                                 // create object
                                 abstractFactory = new AbstractFactoryAnnotation ( ) ;
                                  
                                 // assign statement
                                 abstractFactory.setClassification (1);
                                  
                                 // create link
                                 abstractFactory.addToElements ("concreteFactory", concreteFactoryClass);
                                  
                                 // create link
                                 abstractFactory.addToElements ("abstractFactory", abstractFactoryClass);
                                  
                                 // create link
                                 abstractFactory.addToBoundObjects ("concreteFactoryMethod", concreteFactoryMethod);
                                  
                                 // create link
                                 abstractFactory.addToBoundObjects ("concreteFactoryClass", concreteFactoryClass);
                                  
                                 // create link
                                 abstractFactory.addToBoundObjects ("abstractFactoryClass", abstractFactoryClass);
                                  
                                 // create link
                                 abstractFactory.addToBoundObjects ("abstractFactoryMethod", abstractFactoryMethod);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object factoryMethod1 is really bound
                                 JavaSDM.ensure ( factoryMethod1 != null ) ;
                                  
                                 // check object abstractFactory is really bound
                                 JavaSDM.ensure ( abstractFactory != null ) ;
                                  
                                 // create link
                                 abstractFactory.addToAntecedentAnnos (factoryMethod1);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (abstractFactory) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object abstractFactory is really bound
            JavaSDM.ensure ( abstractFactory != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_FactoryMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (abstractFactory) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("concreteFactory", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("abstractFactory", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof FactoryMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_FactoryMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod = null ;
      Iterator fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass abstractFactoryClass = null ;
      UMLClass concreteFactoryClass = null ;
      UMLMethod abstractFactoryMethod = null ;
      UMLMethod concreteFactoryMethod = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("FactoryMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            concreteFactoryClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind concreteFactoryMethod: UMLMethod
            fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod = concreteFactoryClass.iteratorOfMethods () ;
            while ( fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod.hasNext () )
            {
               try
               {
                  concreteFactoryMethod = (UMLMethod) fujaba__IterConcreteFactoryClassMethodsConcreteFactoryMethod.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteFactoryMethod);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractFactoryClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractFactoryMethod: UMLMethod
            fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod = abstractFactoryClass.iteratorOfMethods () ;
            while ( fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod.hasNext () )
            {
               try
               {
                  abstractFactoryMethod = (UMLMethod) fujaba__IterAbstractFactoryClassMethodsAbstractFactoryMethod.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractFactoryMethod);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
