package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class MultiReferenceEngine
extends GFRNEngine
{
   private  MultiReferenceEngine()
   {
   }

   private static MultiReferenceEngine theMultiReferenceEngine;

   public static MultiReferenceEngine get()
   {
      if (theMultiReferenceEngine == null)
      {
         theMultiReferenceEngine = new MultiReferenceEngine ();
      }
      return theMultiReferenceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation multiReference = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         multiReference = this.annotateUsingFieldRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( multiReference != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (multiReference) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            multiReference = this.annotateUsingTrigger_ContainerAccessRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (multiReference) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               multiReference = this.annotateUsingReferencesRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            return (multiReference) ;
         }
      }
   }


   private GFRNAnnotation annotateUsingFieldRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess3 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess2 = null ;
      Iterator fujaba__IterContainerAccess3ElementsUMLParam4 = null ;
      Iterator fujaba__IterUMLAttr1AnnotationsContainerAccess3 = null ;
      Iterator fujaba__IterUMLAttr1AnnotationsDoubleContainerAccess2 = null ;
      Iterator fujaba__IterUMLAttr1AnnotationsMultiReference = null ;
      MultiReferenceAnnotation multiReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr1 = null ;
      UMLClass uMLClass5 = null ;
      UMLParam uMLParam4 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr1 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess3: ContainerAccessAnnotation
            fujaba__IterUMLAttr1AnnotationsContainerAccess3 = uMLAttr1.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLAttr1AnnotationsContainerAccess3.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLAttr1AnnotationsContainerAccess3.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess3 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess3 and uMLAttr1
                  JavaSDM.ensure ( containerAccess3.hasInElements ("field", uMLAttr1) ) ;
                   
                  // bind uMLParam4: UMLParam
                  fujaba__IterContainerAccess3ElementsUMLParam4 = containerAccess3.iteratorOfElements ("param") ;
                  while ( fujaba__IterContainerAccess3ElementsUMLParam4.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess3ElementsUMLParam4.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                        uMLParam4 = (UMLParam) fujaba__TmpObject ;
                         
                        // bind uMLClass5: UMLClass
                        fujaba__TmpObject = uMLParam4.getParamType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        uMLClass5 = (UMLClass) fujaba__TmpObject ;
                         
                        // check To-Many-Link 'annotations' between uMLAttr1 and doubleContainerAccess2
                        fujaba__IterUMLAttr1AnnotationsDoubleContainerAccess2 = uMLAttr1.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr1AnnotationsDoubleContainerAccess2.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterUMLAttr1AnnotationsDoubleContainerAccess2.next () ;
                            
                           if ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation )
                           {
                              doubleContainerAccess2 = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                               
                              JavaSDM.ensure ( !(doubleContainerAccess2.hasInElements ("field", uMLAttr1)) ) ;
                           }
                        } // while
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object uMLAttr1 is really bound
                              JavaSDM.ensure ( uMLAttr1 != null ) ;
                               
                              // check object uMLClass5 is really bound
                              JavaSDM.ensure ( uMLClass5 != null ) ;
                               
                              // bind multiReference: MultiReferenceAnnotation
                              fujaba__IterUMLAttr1AnnotationsMultiReference = uMLAttr1.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterUMLAttr1AnnotationsMultiReference.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr1AnnotationsMultiReference.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                    multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiReference and uMLAttr1
                                    JavaSDM.ensure ( multiReference.hasInElements ("field", uMLAttr1) ) ;
                                     
                                    // check To-Many-Link 'elements' between multiReference and uMLClass5
                                    JavaSDM.ensure ( multiReference.hasInElements ("references", uMLClass5) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object uMLAttr1 is really bound
                                 JavaSDM.ensure ( uMLAttr1 != null ) ;
                                  
                                 // check object uMLClass5 is really bound
                                 JavaSDM.ensure ( uMLClass5 != null ) ;
                                  
                                 // create object
                                 multiReference = new MultiReferenceAnnotation ( ) ;
                                  
                                 // assign statement
                                 multiReference.setClassification (0);
                                  
                                 // create link
                                 multiReference.addToElements ("field", uMLAttr1);
                                  
                                 // create link
                                 multiReference.addToElements ("references", uMLClass5);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object containerAccess3 is really bound
                                 JavaSDM.ensure ( containerAccess3 != null ) ;
                                  
                                 // check object multiReference is really bound
                                 JavaSDM.ensure ( multiReference != null ) ;
                                  
                                 // create link
                                 multiReference.addToAntecedentAnnos (containerAccess3);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (multiReference) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (multiReference) ;
   }


   private GFRNAnnotation annotateUsingReferencesRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess13 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess12 = null ;
      Iterator fujaba__IterContainerAccess13ElementsUMLAttr11 = null ;
      Iterator fujaba__IterUMLAttr11AnnotationsDoubleContainerAccess12 = null ;
      Iterator fujaba__IterUMLAttr11AnnotationsMultiReference = null ;
      Iterator fujaba__IterUMLClass15RevParamTypeUMLParam14 = null ;
      Iterator fujaba__IterUMLParam14AnnotationsContainerAccess13 = null ;
      MultiReferenceAnnotation multiReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr11 = null ;
      UMLClass uMLClass15 = null ;
      UMLParam uMLParam14 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass15 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam14: UMLParam
            fujaba__IterUMLClass15RevParamTypeUMLParam14 = uMLClass15.iteratorOfRevParamType () ;
            while ( fujaba__IterUMLClass15RevParamTypeUMLParam14.hasNext () )
            {
               try
               {
                  uMLParam14 = (UMLParam) fujaba__IterUMLClass15RevParamTypeUMLParam14.next () ;
                   
                  // bind containerAccess13: ContainerAccessAnnotation
                  fujaba__IterUMLParam14AnnotationsContainerAccess13 = uMLParam14.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLParam14AnnotationsContainerAccess13.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLParam14AnnotationsContainerAccess13.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess13 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess13 and uMLParam14
                        JavaSDM.ensure ( containerAccess13.hasInElements ("param", uMLParam14) ) ;
                         
                        // bind uMLAttr11: UMLAttr
                        fujaba__IterContainerAccess13ElementsUMLAttr11 = containerAccess13.iteratorOfElements ("field") ;
                        while ( fujaba__IterContainerAccess13ElementsUMLAttr11.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess13ElementsUMLAttr11.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              uMLAttr11 = (UMLAttr) fujaba__TmpObject ;
                               
                              // check To-Many-Link 'annotations' between uMLAttr11 and doubleContainerAccess12
                              fujaba__IterUMLAttr11AnnotationsDoubleContainerAccess12 = uMLAttr11.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLAttr11AnnotationsDoubleContainerAccess12.hasNext () )
                              {
                                 fujaba__TmpObject = fujaba__IterUMLAttr11AnnotationsDoubleContainerAccess12.next () ;
                                  
                                 if ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation )
                                 {
                                    doubleContainerAccess12 = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                     
                                    JavaSDM.ensure ( !(doubleContainerAccess12.hasInElements ("field", uMLAttr11)) ) ;
                                 }
                              } // while
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object uMLAttr11 is really bound
                                    JavaSDM.ensure ( uMLAttr11 != null ) ;
                                     
                                    // check object uMLClass15 is really bound
                                    JavaSDM.ensure ( uMLClass15 != null ) ;
                                     
                                    // bind multiReference: MultiReferenceAnnotation
                                    fujaba__IterUMLAttr11AnnotationsMultiReference = uMLAttr11.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterUMLAttr11AnnotationsMultiReference.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLAttr11AnnotationsMultiReference.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                          multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between multiReference and uMLAttr11
                                          JavaSDM.ensure ( multiReference.hasInElements ("field", uMLAttr11) ) ;
                                           
                                          // check To-Many-Link 'elements' between multiReference and uMLClass15
                                          JavaSDM.ensure ( multiReference.hasInElements ("references", uMLClass15) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object uMLAttr11 is really bound
                                       JavaSDM.ensure ( uMLAttr11 != null ) ;
                                        
                                       // check object uMLClass15 is really bound
                                       JavaSDM.ensure ( uMLClass15 != null ) ;
                                        
                                       // create object
                                       multiReference = new MultiReferenceAnnotation ( ) ;
                                        
                                       // assign statement
                                       multiReference.setClassification (0);
                                        
                                       // create link
                                       multiReference.addToElements ("field", uMLAttr11);
                                        
                                       // create link
                                       multiReference.addToElements ("references", uMLClass15);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object containerAccess13 is really bound
                                       JavaSDM.ensure ( containerAccess13 != null ) ;
                                        
                                       // check object multiReference is really bound
                                       JavaSDM.ensure ( multiReference != null ) ;
                                        
                                       // create link
                                       multiReference.addToAntecedentAnnos (containerAccess13);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (multiReference) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("references", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (multiReference) ;
   }


   private GFRNAnnotation annotateUsingTrigger_ContainerAccessRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess8 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess7 = null ;
      Iterator fujaba__IterContainerAccess8ElementsUMLAttr6 = null ;
      Iterator fujaba__IterContainerAccess8ElementsUMLParam9 = null ;
      Iterator fujaba__IterUMLAttr6AnnotationsDoubleContainerAccess7 = null ;
      Iterator fujaba__IterUMLAttr6AnnotationsMultiReference = null ;
      MultiReferenceAnnotation multiReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr6 = null ;
      UMLClass uMLClass10 = null ;
      UMLParam uMLParam9 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_ContainerAccess", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess8 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr6: UMLAttr
            fujaba__IterContainerAccess8ElementsUMLAttr6 = containerAccess8.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess8ElementsUMLAttr6.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess8ElementsUMLAttr6.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr6 = (UMLAttr) fujaba__TmpObject ;
                   
                  // bind uMLParam9: UMLParam
                  fujaba__IterContainerAccess8ElementsUMLParam9 = containerAccess8.iteratorOfElements ("param") ;
                  while ( fujaba__IterContainerAccess8ElementsUMLParam9.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess8ElementsUMLParam9.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                        uMLParam9 = (UMLParam) fujaba__TmpObject ;
                         
                        // bind uMLClass10: UMLClass
                        fujaba__TmpObject = uMLParam9.getParamType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        uMLClass10 = (UMLClass) fujaba__TmpObject ;
                         
                        // check To-Many-Link 'annotations' between uMLAttr6 and doubleContainerAccess7
                        fujaba__IterUMLAttr6AnnotationsDoubleContainerAccess7 = uMLAttr6.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr6AnnotationsDoubleContainerAccess7.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterUMLAttr6AnnotationsDoubleContainerAccess7.next () ;
                            
                           if ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation )
                           {
                              doubleContainerAccess7 = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                               
                              JavaSDM.ensure ( !(doubleContainerAccess7.hasInElements ("field", uMLAttr6)) ) ;
                           }
                        } // while
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object uMLAttr6 is really bound
                              JavaSDM.ensure ( uMLAttr6 != null ) ;
                               
                              // check object uMLClass10 is really bound
                              JavaSDM.ensure ( uMLClass10 != null ) ;
                               
                              // bind multiReference: MultiReferenceAnnotation
                              fujaba__IterUMLAttr6AnnotationsMultiReference = uMLAttr6.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterUMLAttr6AnnotationsMultiReference.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr6AnnotationsMultiReference.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                    multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiReference and uMLAttr6
                                    JavaSDM.ensure ( multiReference.hasInElements ("field", uMLAttr6) ) ;
                                     
                                    // check To-Many-Link 'elements' between multiReference and uMLClass10
                                    JavaSDM.ensure ( multiReference.hasInElements ("references", uMLClass10) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object uMLAttr6 is really bound
                                 JavaSDM.ensure ( uMLAttr6 != null ) ;
                                  
                                 // check object uMLClass10 is really bound
                                 JavaSDM.ensure ( uMLClass10 != null ) ;
                                  
                                 // create object
                                 multiReference = new MultiReferenceAnnotation ( ) ;
                                  
                                 // assign statement
                                 multiReference.setClassification (0);
                                  
                                 // create link
                                 multiReference.addToElements ("field", uMLAttr6);
                                  
                                 // create link
                                 multiReference.addToElements ("references", uMLClass10);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object containerAccess8 is really bound
                                 JavaSDM.ensure ( containerAccess8 != null ) ;
                                  
                                 // check object multiReference is really bound
                                 JavaSDM.ensure ( multiReference != null ) ;
                                  
                                 // create link
                                 multiReference.addToAntecedentAnnos (containerAccess8);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (multiReference) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_ContainerAccess", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (multiReference) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof DoubleContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_DoubleContainerAccess", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_ContainerAccess", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess17 = null ;
      Iterator fujaba__IterContainerAccess17ElementsUMLAttr18 = null ;
      Iterator fujaba__IterContainerAccess17ElementsUMLAttr19 = null ;
      Iterator fujaba__IterUMLClass15RevParamTypeUMLParam16 = null ;
      Iterator fujaba__IterUMLClass15RevParamTypeUMLParam20 = null ;
      Iterator fujaba__IterUMLParam16AnnotationsContainerAccess17 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr11 = null ;
      UMLAttr uMLAttr18 = null ;
      UMLAttr uMLAttr19 = null ;
      UMLClass uMLClass15 = null ;
      UMLParam uMLParam16 = null ;
      UMLParam uMLParam20 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("DoubleContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr11 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr11);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass15 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam16: UMLParam
            fujaba__IterUMLClass15RevParamTypeUMLParam16 = uMLClass15.iteratorOfRevParamType () ;
            while ( fujaba__IterUMLClass15RevParamTypeUMLParam16.hasNext () )
            {
               try
               {
                  uMLParam16 = (UMLParam) fujaba__IterUMLClass15RevParamTypeUMLParam16.next () ;
                   
                  // bind containerAccess17: ContainerAccessAnnotation
                  fujaba__IterUMLParam16AnnotationsContainerAccess17 = uMLParam16.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLParam16AnnotationsContainerAccess17.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLParam16AnnotationsContainerAccess17.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess17 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess17 and uMLParam16
                        JavaSDM.ensure ( containerAccess17.hasInElements ("param", uMLParam16) ) ;
                         
                        // bind uMLAttr18: UMLAttr
                        fujaba__IterContainerAccess17ElementsUMLAttr18 = containerAccess17.iteratorOfElements ("field") ;
                        while ( fujaba__IterContainerAccess17ElementsUMLAttr18.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess17ElementsUMLAttr18.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              uMLAttr18 = (UMLAttr) fujaba__TmpObject ;
                               
                              {
                                 //  for each flow
                                 set.add (uMLAttr18);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess17 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr19: UMLAttr
            fujaba__IterContainerAccess17ElementsUMLAttr19 = containerAccess17.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess17ElementsUMLAttr19.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess17ElementsUMLAttr19.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr19 = (UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr19);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("ContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr19 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr19);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass15 = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam20: UMLParam
            fujaba__IterUMLClass15RevParamTypeUMLParam20 = uMLClass15.iteratorOfRevParamType () ;
            while ( fujaba__IterUMLClass15RevParamTypeUMLParam20.hasNext () )
            {
               try
               {
                  uMLParam20 = (UMLParam) fujaba__IterUMLClass15RevParamTypeUMLParam20.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLParam20);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
